SystemOrganization addCategory: #DspTinyBlog!
SystemOrganization addCategory: 'DspTinyBlog-Components'!
SystemOrganization addCategory: 'DspTinyBlog-Teapot'!
SystemOrganization addCategory: 'DspTinyBlog-Tests'!

Object subclass: #DspTBBlog
	instanceVariableNames: 'posts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DspTinyBlog'!

DspTBBlog class
	instanceVariableNames: 'uniqueInstance'!

!DspTBBlog commentStamp: 'StephaneDucasse 12/4/2015 15:02' prior: 0!
A TBMongoRepository manages the connection to the Mongo database and contains business rules.

When we start developing it we use Voyage in memory as shown in the initialize method

[[[ 
initialize
	self reset.
	VOMemoryRepository new enableSingleton.
]]]

Then once the model is stable we should change to !

DspTBBlog class
	instanceVariableNames: 'uniqueInstance'!

!DspTBBlog class methodsFor: 'data sample' stamp: 'didierSaintPastou 5/27/2016 08:23'!
createDemoPosts
   "DspTBBlog createDemoPosts"
   self current 
      writeBlogPost: ((DspTBPost title: 'Welcome in TinyBlog' text: 'TinyBlog is a small blog engine made with Pharo.' category: 'TinyBlog') visible: true);
      writeBlogPost: ((DspTBPost title: 'Report Pharo Sprint' text: 'Friday, June 12 there was a Pharo sprint / Moose dojo. It was a nice event with more than 15 motivated sprinters. With the help of candies, cakes and chocolate, huge work has been done' category: 'Pharo') visible: true);
      writeBlogPost: ((DspTBPost title: 'Brick on top of Bloc - Preview' text: 'We are happy to announce the first preview version of Brick, a new widget set created from scratch on top of Bloc. Brick is being developed primarily by Alex Syrel (together with Alain Plantec, Andrei Chis and myself), and the work is sponsored by ESUG. 
      Brick is part of the Glamorous Toolkit effort and will provide the basis for the new versions of the development tools.' category: 'Pharo') visible: true);
      writeBlogPost: ((DspTBPost title: 'The sad story of unclassified blog posts' text: 'So sad that I can read this.') visible: true);
      writeBlogPost: ((DspTBPost title: 'Working with Pharo on the Raspberry Pi' text: 'Hardware is getting cheaper and many new small devices like the famous Raspberry Pi provide new computation power that was one once only available on regular desktop computers.' category: 'Pharo') visible: true)! !

!DspTBBlog class methodsFor: 'singleton' stamp: 'LucFabresse 3/24/2016 15:33'!
current
	"answer the instance of the TBRepository"
	^ uniqueInstance ifNil: [ uniqueInstance := self new ]
  ! !

!DspTBBlog class methodsFor: 'class initialization' stamp: 'LucFabresse 3/18/2016 14:49'!
initialize 
	self reset! !

DspTBBlog initialize!

!DspTBBlog class methodsFor: 'accessing' stamp: 'LucFabresse 3/18/2016 14:48'!
reset
	"self reset"
	uniqueInstance := nil! !

!DspTBBlog methodsFor: 'accessing' stamp: 'LucFabresse 3/18/2016 15:08'!
allBlogPosts
   ^ posts! !

!DspTBBlog methodsFor: 'accessing' stamp: 'LucFabresse 3/18/2016 15:09'!
allBlogPostsFromCategory: aCategory
   ^ self allBlogPosts select: [ :p | p category = aCategory ]! !

!DspTBBlog methodsFor: 'accessing' stamp: 'StephaneDucasse 12/4/2015 15:49'!
allCategories
   ^(self allBlogPosts collect: [ :p | p category ]) asSet! !

!DspTBBlog methodsFor: 'accessing' stamp: 'LucFabresse 3/18/2016 15:09'!
allVisibleBlogPosts
   ^ self allBlogPosts select: [ :p | p isVisible ]! !

!DspTBBlog methodsFor: 'accessing' stamp: 'LucFabresse 3/18/2016 15:09'!
allVisibleBlogPostsFromCategory: aCategory
   ^ self allBlogPosts select: [ :p | p category = aCategory and: [ p isVisible ] ]! !

!DspTBBlog methodsFor: 'initialize' stamp: 'LucFabresse 3/18/2016 14:47'!
initialize
	super initialize.
	posts := OrderedCollection new! !

!DspTBBlog methodsFor: 'operations' stamp: 'LucFabresse 3/18/2016 15:09'!
removeAllPosts
	self allBlogPosts removeAll! !

!DspTBBlog methodsFor: 'accessing' stamp: 'LucFabresse 3/18/2016 15:09'!
size
	^ self allBlogPosts size! !

!DspTBBlog methodsFor: 'operations' stamp: 'LucFabresse 3/18/2016 15:08'!
writeBlogPost: aPost
	"Write the blog post in database"
	self allBlogPosts add: aPost! !

Object subclass: #DspTBPost
	instanceVariableNames: 'category date text title visible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DspTinyBlog'!

!DspTBPost commentStamp: 'StephaneDucasse 12/4/2015 14:51' prior: 0!
A  TBPost is a blog post.

!

!DspTBPost class methodsFor: 'instance creation' stamp: 'StephaneDucasse 12/4/2015 14:44'!
title: aTitle text: aText 
	^ self new
		title: aTitle;
		text: aText;
		yourself! !

!DspTBPost class methodsFor: 'instance creation' stamp: 'StephaneDucasse 12/4/2015 14:45'!
title: aTitle text: aText category: aCategory
	^ (self title: aTitle text: aText)
			category: aCategory;
			yourself! !

!DspTBPost class methodsFor: 'constants' stamp: 'StephaneDucasse 12/4/2015 14:36'!
unclassifiedTag
	^ 'Unclassified'! !

!DspTBPost methodsFor: 'visibility' stamp: 'StephaneDucasse 12/4/2015 14:35'!
beVisible
   self visible: true! !

!DspTBPost methodsFor: 'accessing' stamp: 'StephaneDucasse 12/4/2015 14:32'!
category
	^ category! !

!DspTBPost methodsFor: 'accessing' stamp: 'StephaneDucasse 12/4/2015 14:33'!
category: anObject
	category := anObject
! !

!DspTBPost methodsFor: 'accessing' stamp: 'StephaneDucasse 12/4/2015 14:33'!
date
	^ date! !

!DspTBPost methodsFor: 'accessing' stamp: 'StephaneDucasse 12/4/2015 14:33'!
date: anObject
	date := anObject! !

!DspTBPost methodsFor: 'initialize' stamp: 'LucFabresse 3/24/2016 15:35'!
initialize
	self category: self class unclassifiedTag.
	self date: Date today.
	self notVisible! !

!DspTBPost methodsFor: 'testing' stamp: 'StephaneDucasse 12/4/2015 14:48'!
isUnclassified
   ^ self category = self class unclassifiedTag! !

!DspTBPost methodsFor: 'testing' stamp: 'StephaneDucasse 12/4/2015 14:35'!
isVisible
   ^ self visible! !

!DspTBPost methodsFor: 'visibility' stamp: 'StephaneDucasse 12/4/2015 14:35'!
notVisible
   self visible: false! !

!DspTBPost methodsFor: 'accessing' stamp: 'StephaneDucasse 12/4/2015 14:33'!
text
	^ text! !

!DspTBPost methodsFor: 'accessing' stamp: 'StephaneDucasse 12/4/2015 14:33'!
text: anObject
	text := anObject! !

!DspTBPost methodsFor: 'accessing' stamp: 'StephaneDucasse 12/4/2015 14:33'!
title
	^ title! !

!DspTBPost methodsFor: 'accessing' stamp: 'StephaneDucasse 12/4/2015 14:33'!
title: anObject
	title := anObject! !

!DspTBPost methodsFor: 'accessing' stamp: 'StephaneDucasse 12/4/2015 14:33'!
visible
	^ visible! !

!DspTBPost methodsFor: 'accessing' stamp: 'StephaneDucasse 12/4/2015 14:33'!
visible: anObject
	visible := anObject! !

Object subclass: #DspTBTeapotWebApp
	instanceVariableNames: 'teapot'
	classVariableNames: 'Server'
	poolDictionaries: ''
	category: 'DspTinyBlog-Teapot'!

!DspTBTeapotWebApp commentStamp: 'LucFabresse 3/18/2016 16:33' prior: 0!
I am a tiny web app  to the TinyBlog model.
I display what is contained in TBBlog current.

Launch the Web App using:
[ [ [ 
TBTeapotWebApp start.
]]]

You can now access the app using your Web browser on this URL: *http://localhost:8081/*

To stop the app, use:
[ [ [ 
TBTeapotWebApp stop.			
 ] ] ]
!

!DspTBTeapotWebApp class methodsFor: 'accessing' stamp: 'LucFabresse 3/18/2016 16:05'!
start
	Server ifNil: [ Server := self new start ]! !

!DspTBTeapotWebApp class methodsFor: 'accessing' stamp: 'LucFabresse 3/18/2016 16:05'!
stop
	Server ifNotNil: [ Server stop. Server := nil ]! !

!DspTBTeapotWebApp methodsFor: 'model access' stamp: 'didierSaintPastou 5/26/2016 17:15'!
allPosts
	^ DspTBBlog current allVisibleBlogPosts ! !

!DspTBTeapotWebApp methodsFor: 'html pages' stamp: 'LucFabresse 3/18/2016 17:20'!
errorPage 
	^ String streamContents: [ :s | 
			self renderPageHeaderOn: s. 
			s << '<p>Oups, an error occurred</p>'.
			self renderPageFooterOn: s.
		]! !

!DspTBTeapotWebApp methodsFor: 'html pages' stamp: 'LucFabresse 3/18/2016 17:12'!
homePage
	^ String streamContents: [ :s | 
			self renderPageHeaderOn: s.
			s << '<h1>TinyBlog Web App</h1>'.
			s << '<ul>'.
			self allPosts doWithIndex: [  :aPost :index |
				s << '<li>';
				  << ('<a href="/post/', index asString, '">');
				  << aPost title ;
				  << '</a></li>' ].
			s << '</ul>'.
			self renderPageFooterOn: s.
		]

! !

!DspTBTeapotWebApp methodsFor: 'initialization' stamp: 'LucFabresse 3/18/2016 16:05'!
initialize
	super initialize.
	teapot := Teapot configure: {
   					#port -> 8081. 
   					#debugMode -> true }.! !

!DspTBTeapotWebApp methodsFor: 'html pages' stamp: 'LucFabresse 3/18/2016 17:27'!
pageForPostNumber: aPostNumber
	|currentPost|
	currentPost := self allPosts at: aPostNumber ifAbsent: [ ^ self errorPage ].
	^ String streamContents: [ :s | 
			self renderPageHeaderOn: s. 
			s << ('<h1>', currentPost title, '</h1>').
			s << ('<h3>', currentPost date mmddyyyy, '</h3>').
			s << ('<p> Category: ', currentPost category, '</p>').
			s << ('<p>', currentPost text, '</p>').
			self renderPageFooterOn: s.
		]! !

!DspTBTeapotWebApp methodsFor: 'html rendering' stamp: 'LucFabresse 3/18/2016 16:45'!
renderPageFooterOn: aStream
	aStream << '</body></html>' 
! !

!DspTBTeapotWebApp methodsFor: 'html rendering' stamp: 'LucFabresse 3/18/2016 16:45'!
renderPageHeaderOn: aStream
	aStream << '<html><body>' 
! !

!DspTBTeapotWebApp methodsFor: 'server actions' stamp: 'LucFabresse 3/18/2016 17:25'!
start
	teapot
		GET: '/' -> [ self homePage ];
		GET: '/post/<id>' -> [ :req | self pageForPostNumber: (req at: #id) asNumber ];
		start
		! !

!DspTBTeapotWebApp methodsFor: 'server actions' stamp: 'LucFabresse 3/18/2016 16:06'!
stop

	teapot stop! !

WAComponent subclass: #TBApplicationRootComponent
	instanceVariableNames: 'main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DspTinyBlog-Components'!

!TBApplicationRootComponent class methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/26/2016 16:49'!
canBeRoot
	^ true! !

!TBApplicationRootComponent class methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/26/2016 16:48'!
initialize
	"self initialize"
	| app |
	app := WAAdmin register: self asApplicationAt: 'TinyBlog'.
	app
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: TBSDeploymentLibrary! !

TBApplicationRootComponent initialize!

!TBApplicationRootComponent methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/26/2016 17:11'!
children
	^ { main }! !

!TBApplicationRootComponent methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/27/2016 08:11'!
initialize
	super initialize.
	"main := TBScreenComponent new."
	main := TBPostsListComponent new.! !

!TBApplicationRootComponent methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/27/2016 08:12'!
main: aComponent
	main := aComponent! !

!TBApplicationRootComponent methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/26/2016 17:10'!
renderContentOn: html
	html render: main! !

!TBApplicationRootComponent methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/26/2016 16:53'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot beHtml5.
	anHtmlRoot title: 'TinyBlog'.! !

WAComponent subclass: #TBCategoriesComponent
	instanceVariableNames: 'categories postsList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DspTinyBlog-Components'!

!TBCategoriesComponent class methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/27/2016 08:39'!
categories: aCollectionOfCategories postsList: aTBScreen
	^ self new categories: aCollectionOfCategories; postsList: aTBScreen! !

!TBCategoriesComponent methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 08:28'!
categories
	^ categories! !

!TBCategoriesComponent methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 08:30'!
categories: aCollection
	categories := aCollection! !

!TBCategoriesComponent methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 08:28'!
postsList
	^ postsList! !

!TBCategoriesComponent methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 08:29'!
postsList: aComponent
	postsList := aComponent! !

!TBCategoriesComponent methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 15:35'!
renderCategoryLinkOn: html with: aCategory
	html tbsLinkifyListGroupItem
		class: 'active' if: aCategory = self postsList currentCategory ;
		callback: [ self selectCategory: aCategory ];
		with: aCategory! !

!TBCategoriesComponent methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 16:29'!
renderContentOn: html
	html tbsListGroup: [
		html tbsListGroupItem
			with: [ html strong: 'Categories' ].
				categories do: [ :cat |
					self renderCategoryLinkOn: html with: cat ].
				self renderCategoryLinkOn: html with: 'All']
			! !

!TBCategoriesComponent methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 16:45'!
selectCategory: aCategory
	postsList currentCategory: aCategory ! !

WAComponent subclass: #TBHeaderComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DspTinyBlog-Components'!

!TBHeaderComponent methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/26/2016 17:05'!
renderContentOn: html
	html tbsNavbar beDefault with: [
		html tbsNavbarBrand
			url: '#';
			with: 'TinyBlog' ]! !

WAComponent subclass: #TBPostComponent
	instanceVariableNames: 'post'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DspTinyBlog-Components'!

!TBPostComponent methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/27/2016 08:15'!
date
	^ post date! !

!TBPostComponent methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/27/2016 08:14'!
initialize
	super initialize.
	post := DspTBPost new.! !

!TBPostComponent methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/27/2016 08:22'!
post: aPost 
	post := aPost! !

!TBPostComponent methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/27/2016 08:16'!
renderContentOn: html
	html heading level: 2; with: self title.
	html heading level: 6; with: self date.
	html text: self text! !

!TBPostComponent methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/27/2016 08:15'!
text
	^ post text! !

!TBPostComponent methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/27/2016 08:15'!
title
	^ post title! !

WAComponent subclass: #TBScreenComponent
	instanceVariableNames: 'header'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DspTinyBlog-Components'!

TBScreenComponent subclass: #TBPostsListComponent
	instanceVariableNames: 'currentCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DspTinyBlog-Components'!

!TBPostsListComponent methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 17:10'!
basicRenderCategoriesOn: html
^ html render: (TBCategoriesComponent
categories: (self blog allCategories sorted: [:a :b | a <= b] )
postsList: self)! !

!TBPostsListComponent methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 15:38'!
basicRenderPostsOn: html
^ self readSelectedPosts do: [ :p |
html render: (TBPostComponent new post: p) ]! !

!TBPostsListComponent methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 08:32'!
currentCategory
	^ currentCategory! !

!TBPostsListComponent methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 08:32'!
currentCategory: anObject
	currentCategory := anObject! !

!TBPostsListComponent methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 16:52'!
readSelectedPosts
	^ self currentCategory
		ifNil: [ self blog allVisibleBlogPosts ]
		ifNotNil: [ :arg | 
			self currentCategory = 'All'
				ifTrue: [ self blog allVisibleBlogPosts ]
				ifFalse: [ self blog allVisibleBlogPostsFromCategory: self currentCategory ] ]! !

!TBPostsListComponent methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 16:14'!
renderCategoryColumnOn: html
html tbsColumn
extraSmallSize: 2;
smallSize: 2;
mediumSize: 2;
with: [ self basicRenderCategoriesOn: html ]! !

!TBPostsListComponent methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/27/2016 15:58'!
renderContentOn: html
	super renderContentOn: html.
"	v.1 html tbsContainer: [
		self blog allVisibleBlogPosts do: [ :p |
			html render: (TBPostComponent new post: p) ] ]"
"	v.2 html render: (TBCategoriesComponent
		categories: (self blog allCategories)
		postsList: self).
	html tbsContainer: [
		self readSelectedPosts do: [ :p |
			html render: (TBPostComponent new post: p) ] ]"
"	v.3 super renderContentOn: html.
	html tbsContainer: [
		html tbsRow showGrid;
			with: [
				html tbsColumn
					extraSmallSize: 12;
					smallSize: 2;
					mediumSize: 4;
					with: [
						html render: (TBCategoriesComponent
							categories: (self blog allCategories)
							postsList: self) ].
				html tbsColumn
					extraSmallSize: 12;
					smallSize: 10;
					mediumSize: 8;
					with: [
						self readSelectedPosts do: [ :p |
							html render: (TBPostComponent new post: p) ] ] ] ]"
	html
		tbsContainer: [
			html tbsRow
				showGrid;
				with: [ self renderCategoryColumnOn: html.
					self renderPostColumnOn: html ] ]! !

!TBPostsListComponent methodsFor: 'accessing' stamp: 'didierSaintPastou 5/27/2016 16:14'!
renderPostColumnOn: html
html tbsColumn
extraSmallSize: 10;
smallSize: 10;
mediumSize: 10;
with: [ self basicRenderPostsOn: html ]! !

!TBScreenComponent methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/26/2016 17:15'!
blog
	"Return the current blog in the future we will ask the
	session to return the blog of the currently logged user."
	^ DspTBBlog current! !

!TBScreenComponent methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/26/2016 17:07'!
children
	^ OrderedCollection with: header! !

!TBScreenComponent methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/26/2016 17:06'!
initialize
	super initialize.
	header := TBHeaderComponent new.! !

!TBScreenComponent methodsFor: 'as yet unclassified' stamp: 'didierSaintPastou 5/26/2016 17:07'!
renderContentOn: html
	html render: header! !

TestCase subclass: #DspTBBlogTest
	instanceVariableNames: 'blog post first'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DspTinyBlog-Tests'!

!DspTBBlogTest methodsFor: 'setup' stamp: 'didierSaintPastou 5/26/2016 17:15'!
setUp
	blog := DspTBBlog current.
	blog removeAllPosts.
	
	first := (DspTBPost title: 'A title' text: 'A text' category: 'First Category').
	blog writeBlogPost: first.
	
 	post := (DspTBPost title: 'Another title' text: 'Another text' category: 'Second Category') beVisible! !

!DspTBBlogTest methodsFor: 'setup' stamp: 'didierSaintPastou 5/26/2016 17:15'!
tearDown
	DspTBBlog reset! !

!DspTBBlogTest methodsFor: 'tests' stamp: 'StephaneDucasse 12/4/2015 15:13'!
testAddBlogPost
	blog writeBlogPost: post.
	self assert: blog size equals: 2! !

!DspTBBlogTest methodsFor: 'tests' stamp: 'StephaneDucasse 12/4/2015 15:45'!
testAllBlogPosts
   blog writeBlogPost: post.
   self assert: (blog allBlogPosts) size equals: 2.! !

!DspTBBlogTest methodsFor: 'tests' stamp: 'StephaneDucasse 12/4/2015 15:48'!
testAllBlogPostsFromCategory
   self assert: (blog allBlogPostsFromCategory: 'First Category') size equals: 1! !

!DspTBBlogTest methodsFor: 'tests' stamp: 'StephaneDucasse 12/4/2015 15:48'!
testAllCategories
   blog writeBlogPost: post.
   self assert: (blog allCategories) size equals: 2.! !

!DspTBBlogTest methodsFor: 'tests' stamp: 'StephaneDucasse 12/4/2015 15:48'!
testAllVisibleBlogPosts
   blog writeBlogPost: post.
   self assert: (blog allVisibleBlogPosts) size equals: 1.! !

!DspTBBlogTest methodsFor: 'tests' stamp: 'StephaneDucasse 12/4/2015 15:48'!
testAllVisibleBlogPostsFromCategory
   blog writeBlogPost: post.
   self assert: (blog allVisibleBlogPostsFromCategory: 'First Category') size equals: 0.
   self assert: (blog allVisibleBlogPostsFromCategory: 'Second Category') size equals: 1.! !

!DspTBBlogTest methodsFor: 'tests' stamp: 'LucFabresse 3/18/2016 14:58'!
testRemoveAllBlogPosts
   blog removeAllPosts.
   self assert: blog size equals: 0.! !

!DspTBBlogTest methodsFor: 'tests' stamp: 'StephaneDucasse 12/4/2015 15:40'!
testSize
   self assert: blog size equals: 1! !

!DspTBBlogTest methodsFor: 'tests' stamp: 'StephaneDucasse 12/4/2015 15:51'!
testUnclassifiedBlogPosts
   self assert: (blog allBlogPosts select: [ :p | p isUnclassified ]) size equals: 0.! !

DspTBBlog initialize!

TBApplicationRootComponent initialize!
